<?php

/*

pmPDF - Simple PHP class to create 'pocketmod' style booklets for items on
www.stikkit.com

http://www.aaronland.info/php/pmStikkit/

Copyright (c) 2007 Aaron Straup Cope.

This is free software, you may use it and distribute it under the
same terms as Perl itself.

$Id: pmStikkit.php,v 1.2 2007/02/03 05:10:41 asc Exp $

*/

class pmStikkit extends pmPDF {

		/* ####################################################### */

		function pmStikkit($args=array()){
			$this->_key = $args['key'];
			$this->_pps = $args['pps'];
			$this->_sk = array();
			$this->pmPDF($args);
		}

		/* ####################################################### */

		function collect($type, $args=array()){

			$sk = $this->api_call($type, $args);

			if (! is_array($sk)){
				return 0;
			}
				
			$this->_sk = array_merge($this->_sk, $sk);
			return 1;
		}

		/* ####################################################### */

		function Output($name='', $dest=''){

			$pg = '';

			foreach ($this->_sk as $txt){
				$res = $this->add_text($txt, $pg);
				
				if ($this->_pps){
					$pg = $res['page'] + 1;
				}
			}

			parent::Output($name, $dest);
		}

		/* ####################################################### */

		function api_call($type, $args=array()){

			$url = "http://api.stikkit.com/{$type}.txt?api_key={$this->_key}";

			if (count($args)){
				$params = array();

				foreach ($args as $key => $value){
					$key = urlencode($key);
					$value = urlencode($value);
					$params[] = "$key=$value";
				}

				$str_params = implode("&", $params);
				$url .= "&{$str_params}";
			}

			$ch = curl_init();
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt ($ch, CURLOPT_URL, $url );

			$txt = curl_exec ($ch);

			if (curl_errno($ch)){
				return null;
			}

			$sk  = explode(chr(12), $txt);
			return $sk;
		}

		/* ####################################################### */
}